library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_textio.all;
library std;
use std.textio.all;

entity full_adder_tb is
end entity;

architecture a of full_adder_tb is
   component full_adder is
      port (
         a, b, cin: in std_logic;
         s, cout: out std_logic
      );
   end component;
signal a: std_logic_vector(2 downto 0);
signal o: std_logic_vector(1 downto 0);
begin

uut: full_adder port map (
        a => a(0),
        b => a(1),
        cin => a(2),
        s => o(0),
        cout => o(1)
     );

   test: process
   file infile: text;
   variable fstatus: file_open_status;
   variable buf: line;
   variable stimulus: std_logic_vector(2 downto 0);
   variable expected_o: integer;
   variable vector_valid: boolean;
   begin
      file_open(fstatus,infile,"infile.txt",read_mode);
      while not endfile(infile) loop
         readline(infile, buf);
         read(buf, stimulus, good => vector_valid);
         next when not vector_valid;
         read(buf, expected_o);
         a <= stimulus;
         wait for 20 ns;
         assert to_integer(unsigned(o)) = expected_o
           report "Simulation mismatch!";
      end loop;
      file_close(infile);
         assert false
           report "Simulation OK!";
      wait;
   end process;

end architecture a;
